/*
Created by: X
http://www.createdbyx.com/

The TextFileContentProcessors library is licenced under the 
Creative Commons Attribution-NonCommercial-ShareAlike 2.5 Canada
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/
*/
using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Compiler;
using System.Xml;

namespace TextFileContentProcessors
{

    [ContentTypeWriter]
    public class StringBuilderWriter : ContentTypeWriter<DataContainer>
    {

        protected override void Write(ContentWriter output, DataContainer value)
        {
            // write the string data stored in value as a character array
            output.Write(value.Data.ToCharArray());
        }

        public override string GetRuntimeType(TargetPlatform targetPlatform)
        {
            // return the assembly-qualified name for the StringBuilder type.
            return typeof(System.Text.StringBuilder).AssemblyQualifiedName;
        }

        public override string GetRuntimeReader(TargetPlatform targetPlatform)
        {
            // return the assembly-qualified name for the StringBuilderReader type.
            return typeof(StringBuilderReader).AssemblyQualifiedName;
        }
    }
}